import java.util.ArrayList;

public class Agent {
	int pref_dist;
  	int tolerance;
  	int benefit;
  	int initial_pref;
  	boolean has_ego_shift;
  	
     //agents are given a random 'power' distribution, at the distribuition identified by the parameter, the agent will have the most influence on the shift calculation
  	 //if agents continually fail to have the distribution fall within their toleration range, they will experience an 'ego shift' in which their preferred distribution is moved closer
  	 //to their power distribution, in a sense agents begin to prioritize their own influence 
     int power_dist;
        
  	//strategic agents will send strategic signals after their first round
 	boolean strategic;
 	
 	//adaptive agents will adjust their prefered distribution based on their experiences in previous rounds 
  	boolean adaptive;
    	  	
  	//tracks whether this is the firstime the agent is playing 
  	boolean first_round;
  	
  	ArrayList<Integer> borda_strat = new ArrayList<Integer>();
  
  	public Agent(int justice_pref, int egoist_pref, int tolerance_factor, boolean strat, boolean adap){
        this.pref_dist= justice_pref;
        this.power_dist = egoist_pref;
        this.tolerance = tolerance_factor;
        this.strategic = strat;
        this.adaptive = adap;
        this.benefit = 0;
        initial_pref = pref_dist;
        has_ego_shift = false;
    		first_round = true;
 	}
  
  
  	public int get_pref_dist(){
  		return pref_dist;
  	}
        
        public int get_power_dist(){
            return power_dist;
        }
  
 	public int get_tolerance(){
    	return tolerance;
  	}
  
  	public boolean is_strategic(){
  		return strategic;
  	}
  
 	public boolean is_adaptive(){
  		return adaptive;
  	}
  	
  	public int get_benefit(){
  	    return benefit;
  	}
  	
  	public boolean is_first_round(){
  	    return first_round;
  	}  	
  	
  	public void set_Benefit(int ben){
  	    this.benefit = ben;
  	}
  	
  	public void set_round(){
  	    first_round = false;
  	}
  	
  	public void instantiate_borda_strat(int range) {
  		
  		borda_strat.add(pref_dist);
  		int i = range;
  		int count = 1;
  		//sets up a sincere borda array first, will then manipulate the array for strategic results 
  		while(i > 0) {
  			int t1 = pref_dist + count;
  			int t2 = pref_dist - count;
  			
  			if(t1 <= range) {
  				borda_strat.add(t1);
  				i--;
  			}
  			if(t2 >= 0) {
  				borda_strat.add(t2);
  				i--;
  			}
  			count++;
  		}
  		
  		
  	}
  	
	// the manipulation of the borda vote, has 2 main elements: first, the previous distribution is burried, second, median values, defined by {10,11,12,13} are buried
  	public void borda_manip(int range, int prev, int signal_mode) {
  		int temp_val;
  		int temp_index;
  		
  		//add in burying the modal signal in Signals***********************************************************
  		
  		//burries the previous distribution 
  		if(signal_mode != pref_dist) {
  			temp_val = borda_strat.get(range);
  			temp_index = borda_strat.indexOf(signal_mode);
  			
  			borda_strat.set(range, signal_mode);
  			borda_strat.set(temp_index, temp_val);
  		}
  		
  		if(prev != pref_dist && prev != signal_mode) {
  			temp_val = borda_strat.get(range - 1);
  			temp_index = borda_strat.indexOf(prev);
  			
  			borda_strat.set(range -1 , prev);
  			borda_strat.set(temp_index, temp_val);
  		}
  		
  		//buries median values 
  		if(prev != 12 && pref_dist != 12 && prev != signal_mode) {
  			temp_val = borda_strat.get(range-2);
  			temp_index = borda_strat.indexOf(12);
  			
  			borda_strat.set(range-2, 12);
  			borda_strat.set(temp_index, temp_val);
  		}
  		
  		if(prev != 11 && pref_dist != 11 && prev != signal_mode) {
  			temp_val = borda_strat.get(range-3);
  			temp_index = borda_strat.indexOf(11);
  			
  			borda_strat.set(range-3, 11);
  			borda_strat.set(temp_index, temp_val);
  		}
  		
  		if(prev != 13 && pref_dist != 13 && prev != signal_mode) {
  			temp_val = borda_strat.get(range-4);
  			temp_index = borda_strat.indexOf(13);
  			
  			borda_strat.set(range-4, 13);
  			borda_strat.set(temp_index, temp_val);
  		}
  		if(prev != 10 && pref_dist != 10 && prev != signal_mode) {
  			temp_val = borda_strat.get(range-5);
  			temp_index = borda_strat.indexOf(10);
  			
  			borda_strat.set(range-5, 10);
  			borda_strat.set(temp_index, temp_val);
  		}
  		
  		
  		
  	}
  	
  	public ArrayList <Integer> get_borda_votes(){
  		return borda_strat;
  	}

  	
  	//alternative shift cases, those commented out are based on 
  	public void ego_shift(){
   
  		if(pref_dist < power_dist){
  			pref_dist++;
  		}
  		else if(pref_dist > power_dist) {
  			pref_dist--;
  		}
  		
  		has_ego_shift = true;
  		
  		/*
  		if(pref_dist < power_dist){
           int adjust = (int) ((power_dist - pref_dist)/2);
           if(adjust == 0){
                 adjust = 1;
               }
              pref_dist = pref_dist + adjust ; 
            }
            else if(pref_dist > power_dist){
               int adjust = (int) ((power_dist - pref_dist)/2);
                if(adjust == 0){
                    adjust = -1;
                }
               pref_dist = pref_dist + adjust ;  
            }
            
            */
        }
  	
  	public boolean will_ego_shift(int d) {
  		if(Math.abs(d-pref_dist) > tolerance){
  			return true;
  		}
  		else {
  			return false;
  		}
  		
  	}
  	
  	public boolean is_egoistic() {
  		if(pref_dist == power_dist && initial_pref != power_dist) {
  			return true;
  		}
  		else {
  			return false;
  		}
  	}
  	
  	public boolean has_ego_shifted(){
  		return has_ego_shift;
  	}
  	
  	// startegic signalling consists in shifting the signal in the direction of the agent's preferred distribution by their tolerance
  	public int strategic_median_signal(int prev_d){
  	    if(prev_d == pref_dist){
  	        return pref_dist;
  	    }
  	    else if(prev_d - pref_dist < 0 ){
  	       // System.out.println("then agent sent a strategic signal that is greaster");
  	        return pref_dist + tolerance;
  	    }
  	    else{
  	     //   System.out.println("then agent sent a strategic signal that is lower");
  	        return pref_dist - tolerance;
  	    }
  	}
  	
  	//*****need to revise this to not include benefit, since***** 
  	public void adapt(int d, int max){
  	    if(d-pref_dist > 0 && benefit > 0 && pref_dist != max){  
  	        pref_dist ++;
  	    }
  	    else if(d-pref_dist < 0 && benefit > 0 && pref_dist!= 0){ 
  	        pref_dist --; 
  	    }
  	} 
}
